/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_HtmlVirtualQUEUE__
#define __WL_HtmlVirtualQUEUE__
#include <collectable.h>
#include "platform.h"

class CWLTransactionsObject;

enum HtmlQueueItemType
{
	FRAME,
	XML,
	DTD,
	IMAGE,
	LINK,
	STYLE,
	EMBED,
	APPLET,
	SCRIPT,
	RELEASE,		//! end of session
	TERMINATE,	//! thread blown away
  GENERAL,    // Chaim - added for ParseOnce
	NONE
};

class CWLHtmlVirtualQueue {
public:

public:
	CWLHtmlVirtualQueue() {}
	virtual ~CWLHtmlVirtualQueue() {}

//	virtual bool insert(RVCollectable* item, HtmlQueueItemType type){return true;}
  virtual bool insert(CWLTransactionsObject* pTransObj){return true;}
};

#endif //
