// This function target is to be replaced with each wlHttp.Get/Post
// command which add log capability
function LogGet (httpCommand, NamedTrans) {
	var hCommand
	wlHttp.LogRep_Target = wlHttp.wlTarget
	wlHttp.SaveSource = "Yes"
	if (httpCommand == undefined) {
		if (wlHttp.Url != "" ) hCommand = wlHttp.Url + " (Was set from wlHttp.Url)";
		else if (wlLocals.Url != "" ) hCommand = wlLocals.Url + " (Was set from wlLocals.Url)";
		else if (wlGlobals.Url != "" ) hCommand = wlGlobals.Url + " (Was set from wlGlobals.Url)" ;
		else hCommand = "undefined";
		WriteToLog ("Get",hCommand )
		wlHttp.ActualLogGet ()
		}
	else if (NamedTrans == undefined) {
		hCommand = httpCommand
		WriteToLog ("Get",hCommand)
		wlHttp.ActualLogGet (httpCommand)
	}
	else {
		hCommand = httpCommand + " , Named Transaction= \"" + NamedTrans + "\""
		WriteToLog ("Get",hCommand)
		wlHttp.ActualLogGet (httpCommand, NamedTrans)
  }
	LogReportWriteHeaders()
}

function LogPost (httpCommand, NamedTrans) {
	var hCommand
	wlHttp.LogRep_Target = wlHttp.wlTarget
	wlHttp.SaveSource = "Yes"
	if (httpCommand == undefined) {
		if (wlHttp.Url != "" ) hCommand = wlHttp.Url + " (Was set from wlHttp.Url)";
		else if (wlLocals.Url != "" ) hCommand = wlLocals.Url + " (Was set from wlLocals.Url)";
		else if (wlGlobals.Url != "" ) hCommand = wlGlobals.Url + " (Was set from wlGlobals.Url)" ;
		else hCommand = "undefined";
		WriteToLog ("Post",hCommand )
		wlHttp.ActualLogPost ()
		}
	else if (NamedTrans == undefined) {
		hCommand = httpCommand
		WriteToLog ("Post",hCommand)
		wlHttp.ActualLogPost (httpCommand)
	}
	else {
		hCommand = httpCommand + " , Named Transaction= \"" + NamedTrans + "\""
		WriteToLog ("Post",hCommand)
		wlHttp.ActualLogPost (httpCommand, NamedTrans)
  }
	LogReportWriteHeaders()
}
function PadNumsWithZeros (pNumber, pFixedLen) {
	NumWidth = (pNumber.toString()).length    
	if (NumWidth >= pFixedLen) return pNumber
	
	NewNumber = "00000000000000".substr(0,pFixedLen-NumWidth) + pNumber
	return NewNumber
}


function LogReportLogFrames(piIndentSpace, piDocument, piCurrHttpNo ) {
	var i 
	var j 
	var CurrFrameNo = 0 
	var tmpSourceFileName
	var SourceFileName
	var ExrSourceFileName
	var SourceFile
	var localHeaders

	//Write the main document
	tmpSourceFileName = LogReportFileObj.OutFilesDir +
					 "T" +
					 PadNumsWithZeros(ThreadNum,3) +
					 "-R" +
					 PadNumsWithZeros(RoundNum,3) +
					 "-" + 
					 "Request" + PadNumsWithZeros(piCurrHttpNo,3)
					 
	SourceFileName    = tmpSourceFileName + ".htm"
	ExrSourceFileName = tmpSourceFileName +"-exr.htm"
	
	var SourceFile    = new wlOutputFile (SourceFileName)
	var ExrSourceFile = new wlOutputFile (ExrSourceFileName)

	if (piDocument.wlSource != undefined) {
		SourceFile.Write ( "" + piDocument.wlSource )
	}
	else {
		SourceFile.Write ( "" + piDocument.source )
	}
	delete SourceFile

	if ((wlGlobals.ExpectedDOMs != undefined) &&
	    (wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID] != undefined) &&
	    (wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].document != undefined) &&
	    (wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].document.wlSource != undefined)) {
		ExrSourceFile.Write ( "" + wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].document.wlSource)
	}
	delete ExrSourceFile

	//Write frames of current page
	for ( i = 0 ; i < piDocument.frames.length ; i++ ) {

		CurrFrameNo++

		// The frame Source to outfile
		SourceFileName = LogReportFileObj.OutFilesDir + 
				  "T" + PadNumsWithZeros(ThreadNum,3) +
				  "-R" + PadNumsWithZeros(RoundNum,3) +
				  "-Request" + piCurrHttpNo + "." + PadNumsWithZeros(CurrFrameNo,3) + ".htm"
		SourceFile = new wlOutputFile (SourceFileName)
		if (piDocument.frames[i].document.wlSource != undefined) {
			SourceFile.Write ( "" + piDocument.frames[i].document.wlSource )
		}
		else {
			SourceFile.Write ( "" + piDocument.frames[i].document.source )
		}
		delete SourceFile

		LogReportFileObj.Writeln (piIndentSpace + "### FRAME: Round Num:"+ PadNumsWithZeros(RoundNum,3) + " , Request Num:" + piCurrHttpNo + "." + PadNumsWithZeros(CurrFrameNo,3) + " ###" + piDocument.frames[i].location.href )
		if (piDocument.frames[i].document.wlHeaders != undefined) {
			localHeaders = piDocument.frames[i].document.wlHeaders
		}
		else {
			localHeaders = piDocument.frames[i].document.headers
		}
		
		for ( j = 0 ; j < localHeaders.length ; j++ ) {
			LogReportFileObj.Writeln (piIndentSpace + "[" + localHeaders[j].key + "]: " + localHeaders[j].value)
		}
		if (piDocument.frames[i].document.frames.length > 0) {
		    LogReportLogFrames(piIndentSpace + "     " , piDocument.frames[i].document, piCurrHttpNo + "." + PadNumsWithZeros(CurrFrameNo,3))
		}
		LogReportFileObj.Writeln (piIndentSpace + "------ End " + piDocument.frames[i].location.href + " ------")
	}                
}

function LogReportWriteHeaders() {
	var i 
	var TopDocument
	var localHeaders
	
	if ((RoundNum>=LogStartRound) && (RoundNum<=LogEndRound))  {
		//Write headers
		if (document.wlHeaders != undefined) {
			localHeaders = document.wlHeaders
		}
		else {
			localHeaders = document.headers
		}
		for ( i = 0 ; i < localHeaders.length ; i++ ) {
			LogReportFileObj.Writeln ("[" + localHeaders[i].key + "]: " + localHeaders[i].value)
		}                
		// Write Special logging Indications
		CheckForFieldsWithSameName ()

		//Log the document and frames if exists
		TopDoc = document
		if ((wlHttp.LogRep_Target != undefined ) && (wlHttp.LogRep_Target != "" )) {
				TopDoc = wlHtml.GetFrameByLocation(wlHttp.LogRep_Target)
		}
		LogReportLogFrames("     " , TopDoc, PadNumsWithZeros(LogReportCurrHttp,3)  )
		LogReportFileObj.Writeln ("------ End " + document.location.href + " ------")
	}
}

// This function write to the output file and print the suitable InfoMessage
// Also this function will check whether we need to save the html to an out file
function WriteToLog (Operation,httpCommand) {
	var LogDate = new Date()
	var LogLine = ""
	
	// Zeroing Http command counter each round
	if (LogReportCurrRound < RoundNum) {
		LogReportCurrRound++
		LogReportCurrHttp = 0 
	}
	LogReportCurrHttp++
	
	if ((RoundNum>=LogStartRound) && (RoundNum<=LogEndRound))  {
		FileLogLine     = "##### ("+LogDate.getHours()+ ":"  +LogDate.getMinutes()+":"+LogDate.getSeconds()+") , Round Num:"+PadNumsWithZeros(RoundNum,3)  + " , Request Num:" + PadNumsWithZeros(LogReportCurrHttp,3) + " ###"+Operation+": "+httpCommand
		LogLine = "### " + " Thread: " + PadNumsWithZeros(ThreadNum,3) +  " , Round Num:"+PadNumsWithZeros(RoundNum,3) + " , Request Num:" + PadNumsWithZeros(LogReportCurrHttp,3) + " ### "+Operation+": "+httpCommand

		InfoMessage (LogLine)
		LogReportFileObj.Writeln (FileLogLine)            
	}
}
function CheckForFieldsWithSameName () {
	for (var i=0 ; i<document.forms.length ; i++) {
		for (var j=0 ; j<document.forms[i].elements.length ; j++) {
			if (document.forms[i].elements[j].type == "hidden") {
				for (var k=j+1 ; k<document.forms[i].elements.length ; k++) {
					if (document.forms[i].elements[j].name == document.forms[i].elements[k].name) {
						InfoMessage ("Found duplicate hidden fields (same name) in form ("+i+", action=("+document.forms[i].action+") field name is: "+document.forms[i].elements[j].name)
						break
					}
				}
			}
		}
	}
}
// This function should be called at starting place
// in the agenda from which we want the logging to 
// be given
function StartLogging () {
	if ( libraryFirstInitClient("wlLogReport") ) {
		wlLocals.logreport_firstTime = false
		wlHttp.ActualLogGet = wlHttp.Get
		wlHttp.ActualLogPost = wlHttp.Post
		wlHttp.Get = LogGet
		wlHttp.Post = LogPost
	}
}

// OutFilesDir - Directory for all the log files. 
// StartRound  - The round number to start loging from (Default = 0 ).
// EndRound    - The round number to stop loging.(Default = 999)
function InitLog (OutFilesDir, StartRound, EndRound) {
	// Checking if ThreadNum is defined or not
	// indicate to us if we are working in InitAgenda
	// or in InitClient
	var LogRep_ReplaceExp = /\/|\\|:|\*|\?|"|<|>|\||@|\./ig
	var OutFilesPrefix = OutFilesDir 
	if (typeof GeneratorName != "undefined") {
		OutFilesPrefix += GeneratorName().replace(LogRep_ReplaceExp, "_") + "_"
	}
	
	var FileName = OutFilesPrefix + "LogReport"
	//Display message only for the frist virtual client
	if ( ThreadNum == 0 ) InfoMessage("LogReport is active, Log files are saved in "  + OutFilesDir)
	if (typeof ThreadNum == "undefined") {
		SevereErrorMessage ("The InitLog function can not be activated in the InitAgenda")
	}
	else {
		LogReportFileObj = new wlOutputFile(FileName+ "-T"+PadNumsWithZeros(ThreadNum,3)+ ".log")
	}
	LogReportCurrRound = 0 
	LogReportCurrHttp = 0 
	
	LogReportFileObj.OutFilesDir = OutFilesPrefix 

	if (StartRound != undefined) {
		LogStartRound = StartRound
	}
	else {
		LogStartRound = 1
	}

	if (EndRound != undefined) {
		LogEndRound = EndRound
	}
	else {
		LogEndRound = 1
	}
	StartLogging ()
}
function TerminateLog () {
	LogReportFileObj.Close()
}
