/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// JarsAutoDiscovery.h: interface for the CJarsAutoDiscovery class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JARSAUTODISCOVERY_H__150CE838_A5A7_4568_9849_208894F19779__INCLUDED_)
#define AFX_JARSAUTODISCOVERY_H__150CE838_A5A7_4568_9849_208894F19779__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "tvenv.h"
#include <RVCString.h>


class CJarsAutoDiscovery  : public CFindFileFunctor
{
public:
	CJarsAutoDiscovery();
	virtual ~CJarsAutoDiscovery();

	virtual bool handleFile( const char* filePath );
	bool discoverPath( const char* path, const char* spec, bool lookInSubDirs,
						RVCString& aClassPathVar, const char* separator );

protected:
	RVCString* m_paClassPathVar;
	const char* m_pSeparator;
};

#endif // !defined(AFX_JARSAUTODISCOVERY_H__150CE838_A5A7_4568_9849_208894F19779__INCLUDED_)
