/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_LOAD_ENGINE_EXTERNAL_DECS_H
#define __WL_LOAD_ENGINE_EXTERNAL_DECS_H

enum SynchronizationPointStatus {SynchronizationPointLoadChanged , SynchronizationPointTimeout , SynchronizationPointOK};

enum WLEThreadType { 
	WLEThreadTypeLE, // LoadEngine regular
	WLEThreadTypePC, // Probing Client
	WLEThreadTypeBP // Browser Playback
}; 


enum TypeOfTheUserFile {
	WLEOutputFile,
	WLECopiedFile 
};


#define LE_SET_SE_TRANSLATOR() (void)(0)


#define WLJSNAME_LE_DISABLE_SLEEP				"DisableSleep"
#define WLJSNAME_LE_SLEEP_RANDOM_MIN		"SleepRandomMin"
#define WLJSNAME_LE_SLEEP_RANDOM_MAX		"SleepRandomMax"
#define WLJSNAME_LE_SLEEP_DEVIATION			"SleepDeviation"
#define WLJSNAME_LE_EXCEPTION_ENABLED		"ExceptionEnabled"
#define WLJSNAME_LE_REPORT_CSJS_INTERNAL_ERRORS		"ReportCSJSInternalErrors"
#define WLJSNAME_LE_TIMEOUT_BEFORE_OPERATION "TimeoutBeforeOperation"
#define WLJSNAME_LE_SEND_CLIENT_STATISTICS "SendClientStatistics"
#define WLJSNAME_LE_SEND_CLIENT_STATISTICS_FILTER "SendClientStatisticsFilter"
#define WLJSNAME_LE_JVM_TYPE					  "JVMType"
#define WLJSNAME_LE_CHAR_ENCODING				  "CharEncoding"

#endif __WL_LOAD_ENGINE_DECS_H

