/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
//  File WLDll.h
	
#ifndef __WLDlls_H
#define __WLDlls_H

//#include<windows.h>
#include <ordered.h>
#include <collectable.h>


//##########  The declaration of the class cDll   ######################

//class iLEProtocolProcess;


#include <RVCString.h>

class cDll : public RVCollectable {

public:

	explicit cDll(RVCString& NameDll, RVCString& NameDllForLogMessage);
	~cDll();
	
	

	bool Load(RVCString& /*[out]*/oErrorDescriptrion);
	FARPROC fGetProcAddrss(RVCString& funcName);

	RVCString& GetNameDll() { return m_NameDll; }
	RVCString& GetNameDllForLogMessage() { return m_NameDllForLogMessage; }

private:
#ifdef __TV_UNIX__
	void* m_Hlib;
#else
	HINSTANCE m_Hlib;
#endif //__TV_UNIX__
	RVCString m_NameDll;
	RVCString m_NameDllForLogMessage;

};

class cDLLContainer : public RVOrdered {
public:
  explicit cDLLContainer() {};
  virtual ~cDLLContainer() { clearAndDestroy(); };
};



#endif // __WLDlls_H

