/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright (c) 1993-1995, Radview Software LTD. All Rights Reserved. */
/*
 * localmsg.h  -- Sending local messages through NetView.
 *
 * 	who					when					what
 * Yahali     14-Dec-93     Creation.
 *
 */

#ifndef __LOCALMSG_H
#define __LOCALMSG_H

#include "bool.h"
#include "platform.h"

#if (defined_cplusplus) || (defined __cplusplus)
extern "C" {
#endif

DllExport Bool WINAPI sendLocalMessage(const char* name, const char* data);
DllExport Bool WINAPI postLocalMessage(const char* name, const char* data);

#if (defined_cplusplus) || (defined __cplusplus)
}
#endif


#endif // __LOCALMSG_H

