/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*///////////////////////////////////////////////////////////////////////////////
 * utfcode.h -- double byte encoding header.
 * Copyright (C) GalTech Soft Ltd. 1998-2000. All rights reserved.
 *
///////////////////////////////////////////////////////////////////////////////
*/

#ifndef __UTFCODE_H     /* prevent multiple includes */
#define __UTFCODE_H
int Utf8ToUcs2(LPCSTR lpUtf8, int ccUtf8,
	LPWSTR lpUcs2, int ccUcs2, int *pnBytesUsed = 0);

int Utf7ToUcs2(	char** sourceStart, int ccUtf7,
			 WCHAR** targetStart, int ccUcs2, int *pnBytesUsed = 0);
int Ucs2ToUtf8(LPCWSTR lpUcs2, int ccUcs2, 
	LPSTR lpUtf8, int ccUtf8);
int Ucs2ToUtf7(LPCWSTR lpUcs2, int ccUcs2, 
	LPSTR lpUtf7, int ccUtf7);
#endif //__UTFCODE_H
