/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#include "njs.h"

namespace nJs {



iJSEmbedContext::iJSEmbedContext()
{}

iJSEmbedContext::~iJSEmbedContext()
{}


void iJSEmbedContext::fSignContext( JSContext* rCx )
{
	JS_SetContextPrivate( rCx, reinterpret_cast<void*>(static_cast<iJSEmbedContext*>(this)) );
}

void iJSEmbedContext::fsUnsignContext( JSContext* rCx )
{
	JS_SetContextPrivate( rCx, NULL );
}

iJSEmbedContext* iJSEmbedContext::fsGet( JSContext* rCx )
{
	iJSEmbedContext* rtn = reinterpret_cast<iJSEmbedContext*>( JS_GetContextPrivate( rCx ) );
	return rtn;
}





}
