/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// CommandLinePropertie.h: interface for the CCommandLinePropertie class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMANDLINEPROPERTIE_H__1A200EEC_A676_4B55_9A64_B9F7AB8520CC__INCLUDED_)
#define AFX_COMMANDLINEPROPERTIE_H__1A200EEC_A676_4B55_9A64_B9F7AB8520CC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "log.h"

struct CCommandLineProperties
{
	CCommandLineProperties()
		: batchMode(false)
		, virtualClients(1)
		, timeStamp(etAbsolute)
		, appendLog(false)
		, logSuffix(false)
		, consoleDump(false)
		, messagesOn(false){}
	bool			batchMode;
	size_t			virtualClients;
	TimestampType	timeStamp;
	bool			appendLog;
	bool			logSuffix;
	bool			consoleDump;
	bool			messagesOn;
};

const CCommandLineProperties& getCommandLineProperties();

#endif // !defined(AFX_COMMANDLINEPROPERTIE_H__1A200EEC_A676_4B55_9A64_B9F7AB8520CC__INCLUDED_)
