/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.loadengine;



/**
 * Copyright: Copyright (c) 2002
 * Company:   Radview
 * @author Eyal Shalom
 * @version 1.0
 */

public class JavaUIPlayerOptions
{
  public JavaUIPlayerOptions() {}

  public static void load() {}

	public static long getTimeoutBeforeOperation()
	{
		try {
		    return Long.parseLong(getUIOption("TTBeforeOperation")) * 1000;
		}
		catch(UnsatisfiedLinkError e) {}

		return -1;
	}

	public static int getClientsPerEventQueueFactor()
	{
		try {
			return Integer.parseInt(getUIOption("ClientsPerEventQueueFactor"));
		}
		catch(Throwable e) {}

		return -1;
	}

	/**
	 * The method is registered in LoadEngine
	 */
  public static native String getUIOption(String key);
}
