/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/******************************************************************\
 *	File name : jsLocals.cpp
 *
 *	Author : 
 *
 *	Description : 
 *
 *	History : 
 *
 *	Modifications : 
 *		Who				When				What
 *		---				----				----
 *
\******************************************************************/

/** include files **/
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
//#include <windows.h>

#include "rvjsapi.h"

#include "platform.h"
#include "loadjsdefs.h"
#include "wljsobjects.h"


/** local definitions **/

/** default settings **/

/** external functions **/

/** external data **/

/** internal functions **/

/** public data **/

/** private data **/

/** classes definitions **/

/** public functions **/

/** private functions **/


/******************************************************************************\

   Local functions and properties

\******************************************************************************/

/*
enum wlLocal_tinyid {
	WLLOCAL_ROUND_NUM, WLLOCAL_THREAD_NUM
};

static JSPropertySpec wlLocal_props[] = {
	{WLJSNAME_ROUND_NUM,				WLLOCAL_ROUND_NUM,				JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_READONLY},
	{0}
};

// synchronize this array with the wlLocal_props array
char* wlLocal_values[] = {
	NULL,	// RoundNum
	NULL,	// ThreadNum
	NULL
};

static jsval GetDefaultValue(JSContext* cx, int id)
{
	if (!wlLocal_values[id] || !wlLocal_values[id][0])
		return JSVAL_VOID;

	JSString* str = JS_NewStringCopyZ(cx, wlLocal_values[id]);
	return STRING_TO_JSVAL(str);
}
*/


bool WLJSAddLocalProperties(JSContext* cx, JSObject* obj, int nThread)
{
  //CJSGCRequestBeginEnd GCGuard(cx);
  if (!JS_DefineProperty(cx,obj,WLJSNAME_ROUND_NUM,INT_TO_JSVAL(0),NULL,NULL,JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_READONLY))
    return false;
	if (!JS_DefineProperty(cx, obj, WLJSNAME_THREAD_NUM, INT_TO_JSVAL(nThread),NULL, NULL, JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_READONLY))
		return false;
	if (!JS_DefineProperty(cx, obj, WLJSNAME_CLIENT_NUM, INT_TO_JSVAL(nThread),NULL, NULL, JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_READONLY))
		return false;

/*
  for (int i = 0; wlLocal_props[i].name; i++)
		if (!JS_DefineProperty(cx, obj, wlLocal_props[i].name, GetDefaultValue(cx, i),
							wlLocal_props[i].getter, wlLocal_props[i].setter, wlLocal_props[i].flags))
			return false;
*/

	return true;
}

