/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <RVCString.h>

#include "wlerrorlib.h"
#include "loadjsshell.h"
#include "loadexceptions.h"
#include "loadengineglobals.h"
#include "loadthreadinstance.h"
#include "loadthreadsmanager.h"
#include "rtamscript.h"
*/
/*
CRTAMScript(const char* script)
{
  try {
    m_ThreadData = new CLoadGeneratorThreadData(&m_ThreadInstance);
    RegisterWLENewThreadDataFunc(???);
    RegisterWLInitGeneratorScript(???);
    RegisterWLInitGeneratorThread(???);

    m_jsScript.Init();
    bool status = jsScript.LoadScript("demoscript.js" , script);
    if (!status) {
      throw WLErrorException(LoadExceptionFrmFile, 34, jsScript.GetError());
    }
    m_jsThread.Init(&m_jsScript,1);
  }
  catch (WLErrorException e) {
    throw e;
  }
  catch (...) {
    throw WLErrorException();
  }
}    

WLLogMessage::Severity CRTAMScript::Execute(RVCString& stat, RVCString& log)
{
  try {
    m_ThreadData.resetTimer("Round time");
    if (!jsThread.ExecScript(1)) {
      throw WLErrorException(LoadExceptionFrmFile, 35, jsThread.GetError());
    }
    m_ThreadData.sendTimer("Round time");
    //
    // get the log-messages & statistics.
    pcThreadData.DumpStatisticsToString(stat);
    log = pcThreadData.GetLogMessagesBuffer();
  }
  catch (WLErrorException e) {
    throw e;
  }
  catch (...) {
    throw WLErrorException();
  }
}

~CRTAMScript()
{
}
*/
/*
//
// HTTP Loaduar functions:
CLoadGeneratorThreadData* JSNewTestThread(CLoadThreadInstance *threadInstance)
{
  return NULL;
}
bool WLInitTestGeneratorThread(JSContext* cx, JSObject* obj, CLoadEngineVariablesData* pVariablesData)
{
  return true;
}


WLLogMessage::Severity ExecuteScript(const char* script, RVCString& stat, RVCString& log)
{
  RegisterWLENewThreadDataFunc(JSNewTestThread);
//  RegisterWLInitGeneratorShell(WLInitTestGeneratorShell);
//  RegisterWLInitGeneratorScript(WLInitTestGeneratorScript);
  RegisterWLInitGeneratorThread(WLInitTestGeneratorThread);

	RVCString msg;
  char buf[80];

  CProbingClientThreadData pcThreadData;

  try {
    CWLFileDictionary FileDict;
    CLoadThreadsManager agen("sm");
    CLoadThreadInstance ins(&agen, 1);
    //setCurrentThreadInstance(&ins);
    ins.m_ThreadData = &pcThreadData;

//    CWLJSShell jsShell;
//    jsShell.Init();
    CWLJSScript jsScript;
    jsScript.Init();
    bool status = jsScript.LoadScript("demoscript.js" , script);
    if (!status) {
      throw WLErrorException(LoadExceptionFrmFile, 34, jsScript.GetError());
    }
    CWLJSThread jsThread;
    jsThread.Init(&jsScript,1);
    setCurrentThreadInstance(ins.m_ThreadData, jsThread.GetContext());
    
    pcThreadData.resetTimer("Round time");
    if (!jsThread.ExecScript(1)) {
      throw WLErrorException(LoadExceptionFrmFile, 35, jsThread.GetError());
    }
    pcThreadData.sendTimer("Round time");
    //
    // get the log-messages & statistics.
    pcThreadData.DumpStatisticsToString(stat);
    log = pcThreadData.GetLogMessagesBuffer();

    return pcThreadData.getErrorSeverity();;

  } catch (WLErrorException e) {
    cout << "Exception: " << e.GetErrorMsg() << endl;
    WlTraceMsg("Exception: %s",e.GetErrorMsg());
  } catch (...) {
    #ifdef _DEBUG
    throw;
    #endif
  }

  return pcThreadData.getErrorSeverity();;
}

static char buf[1024];

static long getint(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
	return atol(buf);
}

static char* getstr(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
  return buf;
}

int WLProbingClientTest(const char* script)
{
  RVCString scriptName = script;

  CWLFileDictionary FileDict;
  CLoadThreadsManager agen("sm");
  CLoadThreadInstance ins(&agen, 0);
  //setCurrentThreadInstance(&ins);
  CProbingClientThreadData pcThreadData;
  ins.m_ThreadData = &pcThreadData;
  agen.m_NumRunning = 1;
  agen.m_pMyLoadGenerator=NULL;

//  CWLJSShell jsShell;
//  jsShell.Init();
  CWLJSScript jsScript;
  jsScript.Init();
  if (!jsScript.LoadScript(scriptName,NULL)) {
    //throw WLErrorException(LoadExceptionFrmFile, 34, jsScript.GetError());
    cout << "Error " << jsScript.GetError() <<" while loading script" << endl;
    return 0;
  }
  CWLJSThread jsThread;
  jsThread.Init(&jsScript,1);
  setCurrentThreadInstance(ins.m_ThreadData, jsThread.GetContext());

	int choice = 0;
	while (1) {
		switch (choice)
      {
      case 0:
				cout << endl
						 << "1. Run script" << endl
						 //<< "2. Load new script" << endl
						 << "2. Evaluate string" << endl
						 << "99. Exit" << endl;
				break;

			case 1: 
			{
        if (!jsThread.ExecScript(1)) {
          if (strlen(jsThread.GetError())>0)
            cout << "Error " << jsThread.GetError() <<" while running script" << endl;
        }
        //
        // get the log-messages & statistics.
        RVCString statString;
        pcThreadData.DumpStatisticsToString(statString);
        RVCString logString = pcThreadData.GetLogMessagesBuffer();
        cout << "Stat string: " << statString << endl;
        cout << "Log string: " << logString << endl;
			}
			break;

			case 2: 
			{
        RVCString cmd = getstr("Eval: ");
        while (!cmd.isNull()) {
          const char* ret;
          if (!(ret=jsThread.Evaluate(cmd))) {
            //throw WLErrorException(LoadExceptionFrmFile, 35, jsThread.GetError());
            cout << "Error " << jsThread.GetError() <<" while running script" << endl;
          } else {
            cout <<ret << endl;
          }
          cmd = getstr("Eval: ");
        }
			}
			break;

			case 3: 
			{
			}
			break;

			case 99:
        return 1;

      default:
        cout << "Illegal option" << endl << endl;
        break;
      } // end switch

		choice = getint("Please enter selection: [0]");
  } // end while
}
*/

