/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// rfsservice.h: interface for the RFSService class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RFSSERVICE_H__438125D4_A432_4A7E_8109_2DFCD658665D__INCLUDED_)
#define AFX_RFSSERVICE_H__438125D4_A432_4A7E_8109_2DFCD658665D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "rfs.h"


class DllExport RFSService : public RFS  
{
public:
	RFSService(CNetMessageHandler* connection);
	virtual ~RFSService();

	virtual void ProcessRFSRequest(CAssociativeArray& message, RVCString& symbol);
	virtual void SendRFSResponse(const char* remoteHost, const char* responseSymbol, CAssociativeArray* sendMessage);
};


#endif // !defined(AFX_RFSSERVICE_H__438125D4_A432_4A7E_8109_2DFCD658665D__INCLUDED_)
