/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef  __TVSERR_H
#define  __TVSERR_H

#define TVSERR_MAX_ERROR            4000
#define TVS_SUCCESS              0
#define TVSINTERR_CANNOT_OPEN_FILE_FOR_WRITE  TVSERR_MAX_ERROR+1  //Unable to open file for write
#define TVSINTERR_CANNOT_OPEN_FILE_FOR_READ  TVSERR_MAX_ERROR+2  //Unable to open file for read
#define TVSINTERR_ILEGAL_CONF_WORD    TVSERR_MAX_ERROR+3  //Ilegal configuration word. Meanning ignored.
#define TVSINTERR_PARSE_ERROR      TVSERR_MAX_ERROR+4  //Parse error in configuration file
#define TVSINTERR_CANNOT_GET_MODULE_NAME  TVSERR_MAX_ERROR+5  //Unable to get TVSnv module file name in TVSnv LibMain
#define TVSINTERR_NO_MEMORY      TVSERR_MAX_ERROR+6  //Not enough memory for attempted operation

#endif // __TVSERR_H

