/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __STRFORM_H__
#define __STRFORM_H__

#include <regexp.h>
#include <set.h>
#include <collstr.h>
#include <RVCTokenizer.h>
#include <ordered.h>
#include <string.h>
#include <stdlib.h>

#include "platform.h"

//******************************************************************************
//                           Class TVEFormatString
//******************************************************************************
class DllExport TVEFormatString : public RVCollectableString{

			RVCollectableString  tempStr ;
	 public :
			TVEFormatString(RVCString& str):RVCollectableString(str){}
			TVEFormatString():RVCollectableString() {}
			RVCollectableString& unformat();
			RVCollectableString& format();
			RVCollectableString& operator=(const char* str);
};

#endif

