/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "Windows.h"
#include "stdio.h"
#include "tvenv.h"



//int main(int argc, char* argv[])
int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpstrCmdLine, int cmdShow)
{
  
  const char *path = getenv("PATH");
  const char *additional_path = NULL;
  
  TVEnvContainerClass tvpc;
  additional_path = tvpc.TVEGetEnv("WL_PROXY_ADDITIONAL_PATH");
  char newpath[4048];
  sprintf(newpath,"PATH=%s;%s",path,additional_path);
  putenv(newpath);
  
  
  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  
  memset(&si,0,sizeof(si));
  si.cb=sizeof(si);
  
  
  
  
  //    	CString CommandLine = "\"" + BrowserName + "\"";
  char* progName = "\"certConvertWizard.exe\"";
  
  int status = CreateProcess(NULL, progName, NULL, NULL ,FALSE, DETACHED_PROCESS, NULL, NULL, &si, &pi);
  //int status = CreateProcess(CommandLine.GetBuffer(CommandLine.GetLength()), NULL, NULL, NULL ,FALSE, DETACHED_PROCESS, NULL, NULL, &si, &pi);
  if (!status)
  {
    char err[100];
    
    
    sprintf(err,"Error Occured while running %s (code: %d)\n please contact Tech support.",progName, GetLastError());
    MessageBox(NULL, err, "Certificate Conversion Error", MB_OK);
    return -1;
  }
  return 0;
}
