/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _WebLoad_COMMETHODCLASS_H
#define _WebLoad_COMMETHODCLASS_H

#include <ordered.h>




JSObject* NewComMethodObject( 
	JSContext* cx, 
	const char* name,
  JSObject* parent) ;



//STORE PRIVATE DATA OF THE CON OBJECT. PRIVATE PER VC.
class ComMethodPrivate {
	
public:
	explicit ComMethodPrivate( const char* name, JSObject* parent );
	const RVCString& GetName() const;
  JSObject* GetParent() { return m_parent;}



private:
	RVCString m_name;
  JSObject* m_parent;
};


JSClass* GetComMethodJSClass();



#endif
