/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// ErrorManager.cpp: implementation of the CErrorManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
//#include "ErrorManager.h"
#include <iostream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CErrorManager::CErrorManager(CJSCOMObject *pCOMObject_) : pCOMObject(pCOMObject_)
{

}

CErrorManager::~CErrorManager()
{

}

void CErrorManager :: FormatError(){

	LPVOID lpMsgBuf;

	DWORD res = ::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM
				 | FORMAT_MESSAGE_IGNORE_INSERTS,    NULL,
				 m_ErrInfo.m_hrLastError,
				 MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				 (LPTSTR) &lpMsgBuf, 0,NULL );

	if (m_ErrInfo.m_hrLastError == DISP_E_EXCEPTION){

		
//			LPOLESTR temp_str_w = (LPOLESTR)((pCOMObject->GetExceptionInfo())->bstrSource);
			USES_CONVERSION;
			char *temp_str = OLE2A(temp_str_w);
//			cout<<"BstrSource : "<<temp_str<<endl;

//		//	LPOLESTR temp_str_w1 = (LPOLESTR)((pCOMObject->GetExceptionInfo())->bstrDescription);
			char *temp_str1 = OLE2A(temp_str_w1);
//			cout<<"bstrDescription : "<<temp_str1<<endl;



	}

	pCOMObject->SetErrorDescription((LPTSTR) lpMsgBuf);

	//cout<<"COM Error : "<<(LPTSTR) lpMsgBuf<<endl;

}
